/*-----------------------------------------------------------------------------

 2002, Jeff M Soft und Hardware GmbH, All Rights Reserved

-----------------------------------------------------------------------------*/

#include "Module.h"
#include "E:\\sdk2_se_r\\SEMod_struct.h"
#include "E:\\sdk2_se_r\\SEPin.h"
#include <assert.h>


//#include <fcntl.h>     /* for _O_TEXT and _O_BINARY */
//#include <errno.h>     /* for EINVAL */
//#include <sys\stat.h>  /* for _S_IWRITE */

#include <stdio.h> // files
#include <io.h> // filelenght ..

#include <string.h>
//#include <process.h>
//#include <wchar.h>


#define PN_PLAY 0
#define PN_STOP 1
#define PN_KICK 2
#define PN_CHAN 3
#define PN_VELO 4
#define PN_FROM 5
#define PN_TO   6
#define PN_TEXT 7
#define PN_LOOP 8
#define PN_TURN 9
#define PN_MIDI_OUT 10
#define PN_ADMIN 11


#define SYSTEM_MSG		        0xF0
#define NOTE_OFF                0x80
#define NOTE_ON                 0x90




#define MAX_FILENAME_LENGTH 400

char path[MAX_FILENAME_LENGTH];
// char befehl[MAX_FILENAME_LENGTH];
char buffer[1000];
char thisSEM[100];
//sprintf(author,"s%","by ralph a. cronin FAKE MUSIC ");
   

//FILE *filesave = NULL; errno_t  err3;

//pins actvity
state_type in_stat;

char full_path[MAX_FILENAME_LENGTH];

//SMIDI File out
errno_t err = -1;
FILE *smidi_rec_file  = NULL;
char smidi_rec_name[MAX_FILENAME_LENGTH];
bool isnew = false;

//SMIDI File play
errno_t err0 = -1;
FILE *smidi_play_file  = NULL;
char smidi_play_name[MAX_FILENAME_LENGTH];
bool isnew0 = false;

// diagnose
errno_t err2 = -1;
FILE *textfile = NULL;
char text_filename[MAX_FILENAME_LENGTH];
char text[400];

//flags
bool didonce = false;



int done = 0;

unsigned long flang, taki, last_take;
unsigned long pc , md;
//unsigned long * tak_time;
//unsigned long * tak_midi;
char * tak_note;
int fh;
FILE *stream = NULL;

unsigned long time1;
unsigned long midi;
unsigned long start_time;
unsigned long pause_time;
struct NOTES 
{  
   unsigned long r_time;
   unsigned long r_midi;
} note;

NOTES * noten;
bool got_one = false;
bool memin1;
bool level1;

bool canload;      
bool PLAY;
bool waspause;

bool wasoff;
unsigned long _from,_to;
void Module::sub_process(long buffer_offset, long sampleFrames )
{  
	//float *in1    = buffer_offset + input1_buffer;
    float *in1    = buffer_offset + input1_buffer;
    float *in2    = buffer_offset + input2_buffer;
	float *kick   = buffer_offset + input3_buffer;
    _from = from;
	_to   = to;
		               
        if ((*in1 > 0.2)&&(last_take > 0)) PLAY = true; else PLAY = false;
		if ( *in2 > 0.2) // STOP
		{
			taki = 0;
            got_one = false;
			PLAY    = false;
		}
		if(PLAY)
		{  
		  if((got_one == false)&&(taki <= last_take))
	      {
		   midi        = NOTE_ON  + chan + (tak_note[taki] << 8) + (velo << 16);
		   midi_off[a] = NOTE_OFF + chan + (tak_note[taki] << 8) + (velo << 16); 
           taki++; 

if(loop == 1)
{
		   
	if((_to > 0)&&(_to <= last_take))
	{	   		
		if (taki > _to) 
		{ 
			if(( from > 0)&&(from < to)) taki = from; else taki = 0;
		}
	}	   
	else	   
	{		
		if (taki > last_take) if(( from > 0)&&(_from <last_take)) taki = from; else taki = 0;	  
	}
}
		   got_one = true;
		  }

	      if(got_one == true)
	      {
           if((wasoff == true)&&(*kick > 0.2f))
	       {
		    getPin(PN_MIDI_OUT)->TransmitMIDI(SampleClock(), midi);
            if(last_turn > 0)
			{
			 a++;
			 if(a >= last_turn) a = 0;
			 getPin(PN_MIDI_OUT)->TransmitMIDI(SampleClock(), midi_off[a]);
			}
			got_one = false;
			wasoff  = false;
	       }
		  }
		}
		if(*kick < 0.2f) wasoff = true;
		
        sampleFrames = 0;
}

// The core of a MIDI plugin
void Module::OnMidiData( unsigned long p_clock, unsigned long midi_msg, short pin_id)
{
	
}

Module::Module(seaudioMasterCallback2 seaudioMaster, void *p_resvd1) : SEModule_base(seaudioMaster, p_resvd1)
{
}

void Module::open()
{ 
	a = 0;
	midi_off[0] = 0;

	canload = false;

	done = 0;got_one = false;

	SEModule_base::open();
  
	// choose which function is used to process audio
	SET_PROCESS_FUNC(Module::sub_process);
}

Module::~Module()
{
	
	_fcloseall();
}

// describe the module
bool Module::getModuleProperties (SEModuleProperties* properties)
{

   sprintf_s( thisSEM   ,100, "%s\n", "SNOTE_PLAY_KICK_from_to" );
   int j;

   j  = sprintf_s( buffer    ,1000, "%s\n", " ************************************" );
   j  = sprintf_s( buffer + j,1000, "%s\n", " * 2009 December in Tbingen GERMANY " );
   j += sprintf_s( buffer + j,1000, "%s\n", " *            FAKE MUSIC             " ); 
   j += sprintf_s( buffer + j,1000, "%s\n", " *         by ralph.a.cronin         " ); 
   j += sprintf_s( buffer + j,1000, "%s\n", " ************************************" );
   j += sprintf_s( buffer + j,1000, "%s"  ,   thisSEM );
   j += sprintf_s( buffer + j,1000, "%s\n", " *      PLAYER for SMIDI Files       " );
   j += sprintf_s( buffer + j,1000, "%s\n", " ************************************" );
   j += sprintf_s( buffer + j,1000, "%s\n", " *          enjoy SYNTHEDIT          " );
   j += sprintf_s( buffer + j,1000, "%s\n", " *        by Jeff Mc Clintock        " );
   j += sprintf_s( buffer + j,1000, "%s\n", " ************************************" );

   // MAXIS :
   // j += sprintf( buffer + j, "%s\n", " **************************************************************************************" );//120
   // j += sprintf( buffer + j, "%s\n", "XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX" ); // = 54


	properties->name = thisSEM;	// this is the name the end-user will see

	// return a uni+																																																			que string.
	// if posible include manufacturer and plugin identity
	// this is used internally by SE to identify the plug. No two plugs may have the same id.
	properties->id = thisSEM;

	// Info, may include Author, Web page whatever
	properties->about = buffer;//"by ralph a. cronin and Jeff M";
	return true;
}

// describe the pins (plugs)
bool Module::getPinProperties (long index, SEPinProperties* properties)
{
	switch( index )
	{
	
	
	case 0:
		properties->name				= "PLAY";
		properties->variable_address	= &input1_buffer;
		properties->direction			= DR_IN;
		properties->datatype			= DT_FSAMPLE;
		properties->default_value		= "0";
        properties->datatype_extra      = "10,0,10,0";
		break;
    case 1:
		properties->name				= "STOP";
		properties->variable_address	= &input2_buffer;
		properties->direction			= DR_IN;
		properties->datatype			= DT_FSAMPLE;
		properties->default_value		= "0";
        properties->datatype_extra      = "10,0,10,0";
		break;
    case 2:
		properties->name				= "KICK";
		properties->variable_address	= &input3_buffer;
		properties->direction			= DR_IN;
		properties->datatype			= DT_FSAMPLE;
		properties->default_value		= "0";
        properties->datatype_extra      = "10,0,10,0";
		break;
    case 3:
		properties->name				= "channel";
		properties->variable_address	= &chan;
		properties->datatype_extra		= "range 0,15";
		properties->default_value		= "0";
		properties->direction			= DR_IN;
		properties->datatype			= DT_ENUM;
		break;
   case 4:
		properties->name				= "velocity";
		properties->variable_address	= &velo;
		properties->datatype_extra		= "range 0,127";
		properties->default_value		= "55";
		properties->direction			= DR_IN;
		properties->datatype			= DT_ENUM;
		break;
   case 5:
	    properties->name				= "step_from";
		properties->variable_address	= &from;
		properties->datatype_extra		= "range 0,2000";
		properties->default_value		= "0";
		properties->direction			= DR_IN;
		properties->datatype			= DT_ENUM;
		break;
   case 6:
	    properties->name				= "step_to";
		properties->variable_address	= &to;
		properties->datatype_extra		= "range 0,2000";
		properties->default_value		= "0";
		properties->direction			= DR_IN;
		properties->datatype			= DT_ENUM;
		break;
	case 7:	
		properties->name                = "SMIDI_PLAYFILE";
        properties->variable_address    = &text_input;
        properties->direction           = DR_IN;
        properties->datatype            = DT_TEXT; 
        properties->flags               = IO_FILENAME;
        properties->datatype_extra      ="snote"; // file extension
        break;
	case 8:
		properties->name				= "loopit";
		properties->variable_address	= &loop;
		properties->datatype_extra		= "range 0,1";
		properties->default_value		= "0";
		properties->direction			= DR_IN;
		properties->datatype			= DT_ENUM;
		break;
    case 9:
		properties->name				= "next noteoff";
		properties->variable_address	= &last_turn;
		properties->datatype_extra		= "range 0,20";
		properties->default_value		= "0";
		properties->direction			= DR_IN;
		properties->datatype			= DT_ENUM;
		break;
	case 10:
		properties->name				= "MIDI Out";
		properties->direction			= DR_OUT;
		properties->datatype			= DT_MIDI2;
		break;
	case 11:
		properties->name				= "on D: DIAGNOSE.TXT";
		properties->variable_address	= &admin;
		properties->direction			= DR_PARAMETER;
        properties->datatype			= DT_BOOL;
		properties->default_value		= "false";
		break;
	
	default:
		return false; // host will ask for plugs 0,1,2,3 etc. return false to signal when done
	};

	return true;
}

void Module::diag(char * melde)
{
 err2= fopen_s(&textfile,"D:\\DIAGNOSE.TXT","a+");
 if(err2 == 0)
 {
	 fwrite(melde, sizeof(char),strlen(melde), textfile);
     fclose(textfile);
 }
}

void Module::OnPlugStateChange(SEPin *pin)
{
    in_stat = getPin(PN_TEXT)->getStatus(); // bei 1 wechsel
    if(in_stat == ((state_type)1))
	{
	CallHost(seaudioMasterResolveFilename,PN_TEXT, MAX_FILENAME_LENGTH, (void *) full_path );
    //sprintf_s(text,400,"stat= %d \n",in_stat);
    //if(err2 == 0) fwrite(text, sizeof(char),strlen(text), textfile);
	if(admin)
	{
    sprintf_s(text,400,"%s\n",full_path);diag(text);
	}
    //sprintf_s(text,400,"text_input= %s \n", text_input);
	//if(err2 == 0) fwrite(text, sizeof(char),strlen(text), textfile);
    wcscpy_s((wchar_t *)&smidi_play_name,strlen(full_path),(wchar_t *)&full_path);// copy name
    canload = true;
	loadarray();
    // err0 =  fopen_s(&smidi_play_file, smidi_play_name,"rb");
	isnew0 = true;
	}// here we got new path if !


/*
    state_type out_stat = ST_STATIC;
	for (int i = 1; i <= 3; i++)
	{
	 in_stat = getPin(i)->getStatus();
	 if( in_stat > ST_STATIC ) 
	         {
				 out_stat = ST_RUN; 
				 break;
	         }
	}
*/

	// 'transmit' new output status to next module 'downstream'
	// getPin(PN_OUTPUT1)->TransmitStatusChange( SampleClock(), out_stat);// statt out_stat ralph
}


void Module::loadarray()
{ 
	  char ch;
      fopen_s(&stream, smidi_play_name , "r+b" );                    // FILEOPEN  ! r+b mode read+binary

      int filehandle = _fileno(stream);
      flang = _filelength(filehandle);
	  flang = flang / sizeof(char);
      flang++;

	  if(admin)
	  {
      sprintf_s(text,400,"%s _fileno flang = %d \n",thisSEM, flang);
	  diag(text);
	  }

      //fclose(stream);// THAT WAS THE MIDIFILE 

      PLAY = false;
     // if(tak_time != NULL) delete [] tak_time;                // delete if used before
      if(tak_note != NULL) delete [] tak_note;
     
      //tak_time = new unsigned long [flang];         // resize ARRAY reset ARRAYINDEX
      tak_note = new char [flang];

	  
      //if(stream) fclose (stream);

      //fopen_s(&stream, smidi_play_name , "r+b" );                    // FILEOPEN  ?rb
	  taki = 0; 
      while(! feof(stream))
      {
              // fread(&pc,sizeof(unsigned long ),1,stream);        // TIME_pc_clock
      //tak_time[taki]= pc;
               fread(&ch,sizeof(char ),1,stream);        // MIDI_msg
      tak_note[taki]= ch;
                    taki++;                                      // next two    
	  }
	  
      fclose(stream);// THAT WAS THE MIDIFILE 
          last_take = --taki;                                 // EndMarker
		  last_take--;
          taki = 0; pause_time = 0;
      if(admin)
	  {
      sprintf_s(text,400,"%s last_take= %d \n",thisSEM, last_take); diag(text);
	  }
}



