#if !defined(_SEModule_h_inc_)
#define _SEModule_h_inc_

#include "E:\\sdk2_se_r\\SEModule_base.h"
#include <stdio.h> 

class Module : public SEModule_base
{
public:
	Module(seaudioMasterCallback2 seaudioMaster, void *p_resvd1);
	~Module();

	static bool getModuleProperties (SEModuleProperties* properties); 
	virtual bool getPinProperties (long index, SEPinProperties* properties);
	void SE_CALLING_CONVENTION sub_process(long buffer_offset, long sampleFrames );
	void OnPlugStateChange(SEPin *pin);
	virtual void OnMidiData( unsigned long p_clock, unsigned long midi_msg, short pin_id);
	void open();

    void diag(char * melde);
	void loadarray();
private:
    float *input1_buffer; // pointer to circular buffer of samples
	float *input2_buffer;
	float *input3_buffer;
	
    int stat;// on off ...
    //int chan;// 0 = channel 1
	int b2;//pitch     was = ( midi_msg / 0x100 ) & 0xff;
	int b3;//velocity  was = ( midi_msg / 0x10000 ) & 0xff;
    unsigned long this_midi;
	unsigned long midi_off[20];
	short loop;
	short only;
	short chan;
	short velo;
	short from,to;
	short a,b,turn,last_turn;
	bool admin;

    char *text_input;

	

};
#endif
